﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
Sub Class_Globals
	Private OutFile As RandomAccessFile
	Private StopRecording As Boolean
	Private TDL As TargetDataLineWrapper
	Private DataSize As Int = 0
	Private RecordRunning As Boolean
	Private mAmplitudeCallBack As Object
	Private mAmplitudelEventName As String
	Private ReportAmplitude As Boolean
	Private mCallBack As Object
	Private mEventName As String
End Sub

'Initializes the object. You can add parameters to this method if needed.
Public Sub Initialize(CallBack As Object,EventName As String)
	mCallBack = CallBack
	mEventName = EventName
	'Initialize the thread to record on
'	Record.Initialise("Rec")
	
End Sub

Public Sub Start(DataLine1 As TargetDataLineWrapper, FilePath As String,FileName As String)
	If Not(DataLine1.IsInitialized) Then Return
	
	'Reset Flags
	StopRecording = False
	RecordRunning = False
	
	TDL = DataLine1
	'Delete the file if it exists to avoid problems with Random access files
	If File.Exists(FilePath,FileName) Then
		File.Delete(FilePath,FileName)
	End If
	
	'Initialize the output file
	OutFile.Initialize2(FilePath,FileName,False,True)
	
	'Write the Wave file header
	WriteWavHeader

	TDL.Flush
	TDL.Start
	
	'Start the thread to record on
	Wait For (Recording) Complete (Resp As Boolean)
	
	TDL.Stop
	

	'Finish writing the WAVE Header
	UpdateHeader
	
	CallSubDelayed(mCallBack,mEventName & "_Complete")
End Sub

Public Sub Stop
	 StopRecording = True
End Sub

Private Sub Recording As ResumableSub		'Ignore

	RecordRunning = True
	
	'ReSet the data size
	DataSize = 0
	Dim BytesRead As Int = 0
	Dim RecDataSize As Int = TDL.BufferSize / 5
	
	Log("Recording...")
	'Do the recording
	Do While True
		Dim RecData(RecDataSize) As Byte
		Dim Sum As Int
		BytesRead = TDL.Read(RecData,0,RecData.Length)
		OutFile.WriteBytes(RecData,0,BytesRead,44+DataSize)
		DataSize = DataSize+BytesRead
		
		'Example only code ----------------------------
		If ReportAmplitude Then
			For i = 0 To 480 Step 2			'Approx 5ms worth of data (depending on the sample rate)
				Sum=Sum+(RecData(i)*256)+RecData(i+1)
			Next
			CallSubDelayed2(Me,"ShowAmplitude",Sum)
		End If
		'---------------------------
		
		If StopRecording Then 
			Exit
		End If
		Sleep(0)
	Loop

	Return True
End Sub

Public Sub IsRecording As Boolean
	Return RecordRunning
End Sub

'This is an example onl;y and has no specific units
Private Sub ShowAmplitude(Sum As Int)		'ignore
	Sum=Sum/240+(32767/2)
	CallSubDelayed2(mAmplitudeCallBack, mAmplitudelEventName & "_Amplitude",Sum)
End Sub

Public Sub AddAmplitudeListener(CallBack As Object, EventName As String)
	mAmplitudeCallBack = CallBack
	mAmplitudelEventName = EventName
	
	If SubExists(mAmplitudeCallBack,mAmplitudelEventName & "_Amplitude") Then ReportAmplitude = True
End Sub

Private Sub WriteWavHeader
	
	Dim AudioFormat As JavaObject = TDL.TargetDataLine.RunMethod("getFormat",Null)
	
	
	Dim ChannelConfig As Int  = AudioFormat.RunMethod("getChannels",Null)
	Dim SampleRateInHz As Float = AudioFormat.RunMethod("getSampleRate",Null)
	Dim SampleSizeInBits As Int = AudioFormat.RunMethod("getSampleSizeInBits",Null)

	Dim Pos,IntLen,ShLen As Int
	Pos=0
	IntLen=4
	ShLen=2
	Dim Msg As String = "RIFF"
	OutFile.WriteBytes(Msg.GetBytes("UTF8"),0,Msg.Length,Pos)
	Pos=Pos+IntLen
	OutFile.WriteInt(0,Pos)				'Final size not yet known
	Pos=Pos+IntLen
	Msg = "WAVE"
	OutFile.WriteBytes(Msg.GetBytes("UTF8"),0,Msg.Length,Pos)
	Pos=Pos+IntLen
	Msg = "fmt "
	OutFile.WriteBytes(Msg.GetBytes("UTF8"),0,Msg.Length,Pos)
	Pos=Pos+IntLen
	OutFile.WriteInt(16,Pos)				'Sub chunk size 16 for PCM
	Pos=Pos+IntLen
	OutFile.WriteShort(1,Pos)				'Audio Format, 1 for PCM
	Pos=Pos+ShLen
	OutFile.WriteShort(ChannelConfig,Pos)				'No of Channels		(Pos = 22)
	Pos=Pos+ShLen
	OutFile.WriteInt(SampleRateInHz,Pos)					'(Pos = 24)
	Pos=Pos+IntLen
	OutFile.WriteInt(SampleRateInHz * SampleSizeInBits * ChannelConfig / 8,Pos)	'Byte Rate
	Pos=Pos+IntLen
	OutFile.WriteShort(ChannelConfig * SampleSizeInBits / 8,Pos)	'Block align, NumberOfChannels*BitsPerSample/8
	Pos=Pos+ShLen
	OutFile.WriteShort(SampleSizeInBits,Pos)	'BitsPerSample			(Pos = 34)
	Pos=Pos+ShLen
	Msg = "data"
	OutFile.WriteBytes(Msg.GetBytes("UTF8"),0,Msg.Length,Pos)
	Pos=Pos+IntLen
	OutFile.WriteInt(0,Pos)			'Data chunk size (Not yet known)
	
End Sub

Private Sub UpdateHeader
	Log("UpdateHeader DataSize " & DataSize)
	OutFile.WriteInt(36 + DataSize, 4)
	OutFile.WriteInt(DataSize, 40)
	OutFile.Flush
	OutFile.Close
End Sub